/*  Borland C demo                                  */
/*                                                  */
/*  Please see Visual C samples for more details    */
/*  and Visual C++ programs                         */
/*                                                  */


#include <stdio.h>
#include <windows.h>
#include <conio.h>
#include <memory.h>


#include "..\..\MS Visual C\medefines.h"
#include "..\..\MS Visual C\DLLInit.h"           // for using with dynamic DLL accessing

#ifdef __BORLANDC__
#include <condefs.h>
USEFILE("..\..\MS Visual C\medefines.h");
USEFILE("..\..\MS Visual C\DLLInit.h");
USEUNIT("..\..\MS Visual C\DLLInit.cpp");
#endif

#include <TestConsoleGeneric.c>


int main(int argc, char* argv[])
{
    meOpenDynamicAccess();
    
	// Call generic console function in parent directory to 
	// open system and list the available devices and subdevices.

	int i_number_of_devices = TestConsoleMEIDSProlog();

	if(i_number_of_devices <= 0)
	{
		return(-1);
	}

	// ---------------------------------------------------------------------
	
	// Count the DO and DIO sub-devices in the system

	int i_number_do_dio_subdevices = 0;

	int i_me_error;

	for(int index_device = 0; index_device < i_number_of_devices; index_device++)
	{
		int i_vendor_id;
		int i_device_id;
		int i_serial_no;
		int i_bus_type;
		int i_bus_no;
		int i_dev_no;
		int i_func_no;
		int i_plugged;
		
		i_me_error = meQueryInfoDevice(	index_device,				// Device index
										&i_vendor_id,				// Vendor ID returned here - not required				
										&i_device_id,				// Device ID returned here - not required
										&i_serial_no,				// Serial number returned here - not required
										&i_bus_type,				// Bus type returned here - not required
										&i_bus_no,					// Bus number returned here - not required
										&i_dev_no,					// Bus device number returned here - not required
										&i_func_no,					// Bus function number returned here - not required
										&i_plugged				);	// Plugged status returned hee - not required

		if(i_plugged != ME_PLUGGED_IN)
		{
			continue;
		}

		int index_subdevice = 0;

		int i_number_of_subdevices;

		i_me_error = meQueryNumberSubdevices(	index_device,				// Device index
												&i_number_of_subdevices);	// Number of subdevices returned here
		
		while(true)
		{
			i_me_error = meQuerySubdeviceByType(index_device,					// Device
												index_subdevice,				// Begin search at this sub-device 
												ME_TYPE_DO,						// Type of sub-device to search for
												ME_SUBTYPE_ANY,					// Sub-type of sub-device to search for
												&index_subdevice	);			// sub-device index returned here

			if(i_me_error != ME_ERRNO_SUCCESS)
			{
				break;
			}
			
			++i_number_do_dio_subdevices;

			if(++index_subdevice >= i_number_of_subdevices)
			{
				break;
			}
		}

		index_subdevice = 0;
		
		while(true)
		{
			i_me_error = meQuerySubdeviceByType(index_device,					// Device
												index_subdevice,				// Begin search at this sub-device 
												ME_TYPE_DIO,					// Type of sub-device to search for
												ME_SUBTYPE_ANY,					// Sub-type of sub-device to search for
												&index_subdevice	);			// sub-device index returned here

			if(i_me_error != ME_ERRNO_SUCCESS)
			{
				break;
			}
			
			++i_number_do_dio_subdevices;

			if(++index_subdevice >= i_number_of_subdevices)
			{
				break;
			}
		}
	}

	if(i_number_do_dio_subdevices == 0)
	{
		printf("****    No DO or DIO sub-devices found in system    ****\n\n");
		
		printf("Press any key to terminate\n");
		
		_getch();
		
		meClose(0);
		
		return -1;
	}

	// Make a list of the DO and DIO sub-devices

	struct SDigitalOutSubddevice
	{
		int	m_iDeviceIndex;

		int m_iSubdeviceIndex;

		int m_iType;

		int m_iWidth;

		int m_bDOSinkSource;
	};

	SDigitalOutSubddevice* arrSubdevices = new SDigitalOutSubddevice[i_number_do_dio_subdevices];

	i_number_do_dio_subdevices = 0;

	for(int index_device = 0; index_device < i_number_of_devices; index_device++)
	{
		int i_vendor_id;
		int i_device_id;
		int i_serial_no;
		int i_bus_type;
		int i_bus_no;
		int i_dev_no;
		int i_func_no;
		int i_plugged;
		
		i_me_error = meQueryInfoDevice(	index_device,				// Device index
										&i_vendor_id,				// Vendor ID returned here - not required				
										&i_device_id,				// Device ID returned here - not required
										&i_serial_no,				// Serial number returned here - not required
										&i_bus_type,				// Bus type returned here - not required
										&i_bus_no,					// Bus number returned here - not required
										&i_dev_no,					// Bus device number returned here - not required
										&i_func_no,					// Bus function number returned here - not required
										&i_plugged				);	// Plugged status returned hee - not required

		if(i_plugged != ME_PLUGGED_IN)
		{
			continue;
		}

		int index_subdevice = 0;
		
		int i_number_of_subdevices;

		i_me_error = meQueryNumberSubdevices(	index_device,				// Device index
												&i_number_of_subdevices);	// Number of subdevices returned here
		
		while(true)
		{
			i_me_error = meQuerySubdeviceByType(index_device,					// Device
												index_subdevice,				// Begin search at this sub-device 
												ME_TYPE_DO,						// Type of sub-device to search for
												ME_SUBTYPE_ANY,					// Sub-type of sub-device to search for
												&index_subdevice	);			// sub-device index returned here

			if(i_me_error != ME_ERRNO_SUCCESS)
			{
				break;
			}

			arrSubdevices[i_number_do_dio_subdevices].m_iDeviceIndex = index_device;

			arrSubdevices[i_number_do_dio_subdevices].m_iSubdeviceIndex = index_subdevice;

			arrSubdevices[i_number_do_dio_subdevices].m_iType = ME_TYPE_DO;

			i_me_error = meQueryNumberChannels(	index_device,											// Device
												index_subdevice,										// Sub-device 
												&arrSubdevices[i_number_do_dio_subdevices].m_iWidth	);	// Number of channels returned here

			int i_caps = 0;
			
			i_me_error = meQuerySubdeviceCaps(	index_device,			// Device
												index_subdevice,		// Sub-device 
												&i_caps				);	// Number of channels returned here

			if( (i_caps & ME_CAPS_DIO_SINK_SOURCE) ==  ME_CAPS_DIO_SINK_SOURCE )
			{
				arrSubdevices[i_number_do_dio_subdevices].m_bDOSinkSource = 1;
			}
			else
			{
				arrSubdevices[i_number_do_dio_subdevices].m_bDOSinkSource = 0;
			}
			
			++i_number_do_dio_subdevices;
			
			if(++index_subdevice >= i_number_of_subdevices)
			{
				break;
			}
		}

		index_subdevice = 0;
		
		while(true)
		{
			i_me_error = meQuerySubdeviceByType(index_device,					// Device
												index_subdevice,				// Begin search at this sub-device 
												ME_TYPE_DIO,					// Type of sub-device to search for
												ME_SUBTYPE_ANY,					// Sub-type of sub-device to search for
												&index_subdevice	);			// sub-device index returned here

			if(i_me_error != ME_ERRNO_SUCCESS)
			{
				break;
			}

			arrSubdevices[i_number_do_dio_subdevices].m_iDeviceIndex = index_device;

			arrSubdevices[i_number_do_dio_subdevices].m_iSubdeviceIndex = index_subdevice;

			arrSubdevices[i_number_do_dio_subdevices].m_iType = ME_TYPE_DIO;

			i_me_error = meQueryNumberChannels(	index_device,											// Device
												index_subdevice,										// Sub-device 
												&arrSubdevices[i_number_do_dio_subdevices].m_iWidth	);	// Number of channels returned here

			arrSubdevices[i_number_do_dio_subdevices].m_bDOSinkSource = 0;
			
			++i_number_do_dio_subdevices;

			if(++index_subdevice >= i_number_of_subdevices)
			{
				break;
			}
		}
	}

	printf("%d DO or DIO sub-devices found:\n\n", i_number_do_dio_subdevices);

	for(int index_subdevice = 0; index_subdevice < i_number_do_dio_subdevices; index_subdevice++)
	{
		printf("%2d.   Device: %2d  Sub-device: %2d  Type: %s  Width: %2d Bits\n",
				index_subdevice + 1,
				arrSubdevices[index_subdevice].m_iDeviceIndex,
				arrSubdevices[index_subdevice].m_iSubdeviceIndex,
				( (arrSubdevices[index_subdevice].m_iType == ME_TYPE_DIO) ? "DIO" : " DO"),
				arrSubdevices[index_subdevice].m_iWidth										);
	}

	printf("\n\nPress any key to continue\n\n");

	getch();

	char buffer[512];
	
	while(true)
	{
		int index_subdevice;

		bool b_terminate = false;

		while(true)
		{
			printf("Choose sub-device:\n\n");

			for(index_subdevice = 0; index_subdevice < i_number_do_dio_subdevices; index_subdevice++)
			{
				printf("    %2d.   Device: %2d  Sub-device: %2d  Type: %s  Width: %2d Bits\n",
						index_subdevice + 1,
						arrSubdevices[index_subdevice].m_iDeviceIndex,
						arrSubdevices[index_subdevice].m_iSubdeviceIndex,
						( (arrSubdevices[index_subdevice].m_iType == ME_TYPE_DIO) ? "DIO" : " DO"),
						arrSubdevices[index_subdevice].m_iWidth										);
			}

			printf("\nYour choice (1 - %2d) (RETURN to terminate): ", i_number_do_dio_subdevices);  

			gets(&buffer[0]);

			printf("\n\n");
			
			if(buffer[0] == 0)
			{
				b_terminate = true;
				
				break;
			}
			
			if( (sscanf(&buffer[0], "%d", &index_subdevice) != 1 ) )
			{
				continue;
			}

			if( (index_subdevice < 1)||(index_subdevice > i_number_do_dio_subdevices) )
			{
				continue;
			}

			--index_subdevice;

			break;
		}

		if(b_terminate)
		{
			break;
		}
			
		int i_output_config;

		if( (arrSubdevices[index_subdevice].m_iType == ME_TYPE_DO)&&(arrSubdevices[index_subdevice].m_bDOSinkSource != 0) )
		{
			int i_index_config = 0;
				
			while(true)
			{
				printf("Choose output configuration:\n\n");

				printf(	"1.  High Impedance\n"
						"2.  Sink\n"
						"3.  Source\n"			);

				printf("\nYour choice (1 - 3) (RETURN to terminate): ");  

				gets(&buffer[0]);

				printf("\n\n");

				if(buffer[0] == 0)
				{
					b_terminate = true;
					
					break;
				}
				
				if( (sscanf(&buffer[0], "%d", &i_index_config) != 1 ) )
				{
					continue;
				}

				if( (i_index_config < 1)||(i_index_config > 3) )
				{
					continue;
				}
				
				break;
			}

			if(b_terminate)
			{
				break;
			}
				
			switch(i_index_config)
			{
			case 1:
				
				i_output_config = ME_SINGLE_CONFIG_DIO_HIGH_IMPEDANCE;

				break;

			case 2:
				
				i_output_config = ME_SINGLE_CONFIG_DIO_SINK;

				break;

			case 3:
				
				i_output_config = ME_SINGLE_CONFIG_DIO_SOURCE;

				break;
			}
		}

		int i_hex_value;

		while(true)
		{
			printf("Value (Hex) to output (RETURN to terminate): 0x");  

			gets(&buffer[0]);

			printf("\n\n");
			
			if(buffer[0] == 0)
			{
				b_terminate = true;
				
				break;
			}
			
			if( (sscanf(&buffer[0], "%X", &i_hex_value) != 1 ) )
			{
				continue;
			}

			break;
		}

		if(b_terminate)
		{
			break;
		}

		char sz_hex_value[16];

		int i_config_flags;
		
		int i_write_flags;
		
		switch(arrSubdevices[index_subdevice].m_iWidth)
		{
		case 1:

			sprintf(&sz_hex_value[0], "%d", (i_hex_value & 0x00000001) );

			i_config_flags = ME_IO_SINGLE_CONFIG_DIO_BIT;

			i_write_flags = ME_IO_SINGLE_TYPE_DIO_BIT;

			break;

		case 8:

			sprintf(&sz_hex_value[0], "0x%02X", (unsigned char)(i_hex_value & 0x000000FF) );

			i_config_flags = ME_IO_SINGLE_CONFIG_DIO_BYTE;

			i_write_flags = ME_IO_SINGLE_TYPE_DIO_BYTE;

			break;

		case 16:

			sprintf(&sz_hex_value[0], "0x%04X", (unsigned short)(i_hex_value & 0x0000FFFF) );

			i_config_flags = ME_IO_SINGLE_CONFIG_DIO_WORD;

			i_write_flags = ME_IO_SINGLE_TYPE_DIO_WORD;

			break;

		case 32:

			sprintf(&sz_hex_value[0], "0x%08X", i_hex_value);

			i_config_flags = ME_IO_SINGLE_CONFIG_DIO_DWORD;

			i_write_flags = ME_IO_SINGLE_TYPE_DIO_DWORD;

			break;
		}

		printf("Press any key to output %s to Device: %d Subdevice: %d\n", &sz_hex_value[0], arrSubdevices[index_subdevice].m_iDeviceIndex, arrSubdevices[index_subdevice].m_iSubdeviceIndex);

		getch();

		printf("\n\n");

		if(arrSubdevices[index_subdevice].m_iType == ME_TYPE_DIO)
		{
			i_me_error = meIOSingleConfig(	arrSubdevices[index_subdevice].m_iDeviceIndex,		// Device index
											arrSubdevices[index_subdevice].m_iSubdeviceIndex,	// Subdevcie index
											0,													// Channel
											ME_SINGLE_CONFIG_DIO_OUTPUT,						// Single config
											ME_VALUE_NOT_USED,									// Reference 
											ME_TRIG_CHAN_DEFAULT,								// Trigger channel
											ME_TRIG_TYPE_NONE,									// Trigger type
											ME_VALUE_NOT_USED,									// Trigger edge
											i_config_flags									);	// Flags

			if(i_me_error != ME_ERRNO_SUCCESS)
			{
				printf("****    meIOSingleConfig - Error: %d    ****\n\n", i_me_error);

				printf("Press any key to terminate\n");
				
				_getch();
				
				meClose(0);
				
				return -1;
			}
		}
		else
		{
			if(arrSubdevices[index_subdevice].m_bDOSinkSource != 0)
			{
				i_me_error = meIOSingleConfig(	arrSubdevices[index_subdevice].m_iDeviceIndex,		// Device index
												arrSubdevices[index_subdevice].m_iSubdeviceIndex,	// Subdevcie index
												0,													// Channel
												i_output_config,									// Single config
												ME_VALUE_NOT_USED,									// Reference 
												ME_VALUE_NOT_USED,									// Trigger channel
												ME_VALUE_NOT_USED,									// Trigger type
												ME_VALUE_NOT_USED,									// Trigger edge
												i_config_flags									);	// Flags

				if(i_me_error != ME_ERRNO_SUCCESS)
				{
					printf("****    meIOSingleConfig - Error: %d    ****\n\n", i_me_error);

					printf("Press any key to terminate\n");
					
					_getch();
					
					meClose(0);
					
					return -1;
				}
			}
		}

		meIOSingle_t io_single[1];

		io_single[0].iDevice = arrSubdevices[index_subdevice].m_iDeviceIndex;

		io_single[0].iSubdevice = arrSubdevices[index_subdevice].m_iSubdeviceIndex;
		io_single[0].iChannel	= 0;
		io_single[0].iDir		= ME_DIR_OUTPUT;
		io_single[0].iValue		= i_hex_value;
		io_single[0].iTimeOut	= 0;							// No timeout - not required for software output
		io_single[0].iFlags		= i_write_flags;
		
		i_me_error = meIOSingle(&io_single[0],				// Output list 
								1,							// Number of elements in the above list 
								ME_IO_SINGLE_NO_FLAGS	);	// Flags

		if(i_me_error != ME_ERRNO_SUCCESS)
		{
			printf("****    meIOSingle - Error: %d    ****\n\n", i_me_error);

			printf("Press any key to terminate\n");
			
			_getch();
			
			meClose(0);
			
			return -1;
		}

		printf("%s output to Device: %d Subdevice: %d - press any key to continue\n", &sz_hex_value[0], arrSubdevices[index_subdevice].m_iDeviceIndex, arrSubdevices[index_subdevice].m_iSubdeviceIndex);


		_getch();
	}

	delete []arrSubdevices;

	// ---------------------------------------------------------------------
	
	meClose(0);
	meCloseDynamicAccess();
	
	printf("Program completed successfully - Press any key to terminate\n\n");

	_getch();
	
	return 0;
}

