/*  Borland C demo                                  */
/*                                                  */
/*  Please see Visual C samples for more details    */
/*  and Visual C++ programs                         */
/*                                                  */


#include <stdio.h>
#include <windows.h>
#include <conio.h>
#include <memory.h>


#include "..\..\MS Visual C\medefines.h"
#include "..\..\MS Visual C\DLLInit.h"           // for using with dynamic DLL accessing

#ifdef __BORLANDC__
#include <condefs.h>
USEFILE("..\..\MS Visual C\medefines.h");
USEFILE("..\..\MS Visual C\DLLInit.h");
USEUNIT("..\..\MS Visual C\DLLInit.cpp");
#endif

#include <TestConsoleGeneric.c>


int main(int argc, char* argv[])
{
    meOpenDynamicAccess();
    
	// Call generic console function in parent directory to 
	// open system and list the available devices and subdevices.

	int i_number_of_devices = TestConsoleMEIDSProlog();

	if(i_number_of_devices <= 0)
	{
		return(-1);
	}

	// ---------------------------------------------------------------------
	
	int i_number_ao_streaming_subdevices = 0;

	int i_me_error;

	// Search for an AO-Streaming subdevice in the system

	for(int index_device = 0; index_device < i_number_of_devices; index_device++)
	{
		int i_vendor_id;
		int i_device_id;
		int i_serial_no;
		int i_bus_type;
		int i_bus_no;
		int i_dev_no;
		int i_func_no;
		int i_plugged;
		
		i_me_error = meQueryInfoDevice(	index_device,				// Device index
										&i_vendor_id,				// Vendor ID returned here - not required				
										&i_device_id,				// Device ID returned here - not required
										&i_serial_no,				// Serial number returned here - not required
										&i_bus_type,					// Bus type returned here - not required
										&i_bus_no,					// Bus number returned here - not required
										&i_dev_no,					// Bus device number returned here - not required
										&i_func_no,					// Bus function number returned here - not required
										&i_plugged				);	// Plugged status returned hee - not required

		if(i_plugged != ME_PLUGGED_IN)
		{
			continue;
		}


		int index_subdevice = 0;

		int i_number_of_subdevices;

		i_me_error = meQueryNumberSubdevices(	index_device,				// Device index
												&i_number_of_subdevices);	// Number of subdevices returned here
		
		while(true)
		{
			i_me_error = meQuerySubdeviceByType(index_device,				// Device
												index_subdevice,			// Begin search at this sub-device 
												ME_TYPE_AO,					// Type of sub-device to search for
												ME_SUBTYPE_STREAMING,		// Sub-type of sub-device to search for
												&index_subdevice		);	// sub-device index returned here

			if(i_me_error != ME_ERRNO_SUCCESS)
			{
				break;
			}
			
			++i_number_ao_streaming_subdevices;

			if(++index_subdevice >= i_number_of_subdevices)
			{
				break;
			}
		}
	}

	if(i_number_ao_streaming_subdevices == 0)
	{
		printf("****    No AO-Streaming sub-device found in system    ****\n\n");
		
		printf("Press any key to terminate\n");
		
		_getch();
		
		meClose(0);
		
		return -1;
	}

	struct SAOStreamingSubddevice
	{
		int	m_iDeviceIndex;

		int m_iSubdeviceIndex;
	};

	SAOStreamingSubddevice* arrSubdevices = new SAOStreamingSubddevice[i_number_ao_streaming_subdevices];

	i_number_ao_streaming_subdevices = 0;

	for(int index_device = 0; index_device < i_number_of_devices; index_device++)
	{
		int i_vendor_id;
		int i_device_id;
		int i_serial_no;
		int i_bus_type;
		int i_bus_no;
		int i_dev_no;
		int i_func_no;
		int i_plugged;
		
		i_me_error = meQueryInfoDevice(	index_device,				// Device index
										&i_vendor_id,				// Vendor ID returned here - not required				
										&i_device_id,				// Device ID returned here - not required
										&i_serial_no,				// Serial number returned here - not required
										&i_bus_type,				// Bus type returned here - not required
										&i_bus_no,					// Bus number returned here - not required
										&i_dev_no,					// Bus device number returned here - not required
										&i_func_no,					// Bus function number returned here - not required
										&i_plugged				);	// Plugged status returned hee - not required

		if(i_plugged != ME_PLUGGED_IN)
		{
			continue;
		}

		int index_subdevice = 0;
		
		int i_number_of_subdevices;

		i_me_error = meQueryNumberSubdevices(	index_device,				// Device index
												&i_number_of_subdevices);	// Number of subdevices returned here
		
		while(true)
		{
			i_me_error = meQuerySubdeviceByType(index_device,					// Device
												index_subdevice,				// Begin search at this sub-device 
												ME_TYPE_AO,						// Type of sub-device to search for
												ME_SUBTYPE_STREAMING,			// Sub-type of sub-device to search for
												&index_subdevice	);			// sub-device index returned here

			if(i_me_error != ME_ERRNO_SUCCESS)
			{
				break;
			}

			arrSubdevices[i_number_ao_streaming_subdevices].m_iDeviceIndex = index_device;

			arrSubdevices[i_number_ao_streaming_subdevices].m_iSubdeviceIndex = index_subdevice;

			++i_number_ao_streaming_subdevices;
			
			if(++index_subdevice >= i_number_of_subdevices)
			{
				break;
			}
		}
	}

	printf("%d AO streaming sub-devices found:\n\n", i_number_ao_streaming_subdevices);

	for(int index_subdevice = 0; index_subdevice < i_number_ao_streaming_subdevices; index_subdevice++)
	{
		printf("%2d.   Device: %2d  Sub-device: %2d\n",
				index_subdevice + 1,
				arrSubdevices[index_subdevice].m_iDeviceIndex,
				arrSubdevices[index_subdevice].m_iSubdeviceIndex	);
	}

	printf("\n\nPress any key to continue\n\n");

	getch();

	char buffer[512];
	
	while(true)
	{
		int index_subdevice;

		bool b_terminate = false;

		while(true)
		{
			printf("Choose sub_device:\n\n");

			for(index_subdevice = 0; index_subdevice < i_number_ao_streaming_subdevices; index_subdevice++)
			{
				printf("    %2d.   Device: %2d  Sub-device: %2d\n",
						index_subdevice + 1,
						arrSubdevices[index_subdevice].m_iDeviceIndex,
						arrSubdevices[index_subdevice].m_iSubdeviceIndex	);
			}

			printf("\nYour choice (1 - %2d) (RETURN to terminate): ", i_number_ao_streaming_subdevices);  

			gets(&buffer[0]);

			printf("\n\n");
			
			if(buffer[0] == 0)
			{
				b_terminate = true;
				
				break;
			}
			
			if( (sscanf(&buffer[0], "%d", &index_subdevice) != 1 ) )
			{
				continue;
			}

			if( (index_subdevice < 1)||(index_subdevice > i_number_ao_streaming_subdevices) )
			{
				continue;
			}

			--index_subdevice;

			break;
		}

		if(b_terminate)
		{
			break;
		}
			

		double d_req_freq = 1000.0;
		double d_achieved_freq = d_req_freq;

		int i_ticks_low = 0;
		int i_ticks_high = 0;

		i_me_error = meIOStreamFrequencyToTicks(arrSubdevices[index_subdevice].m_iDeviceIndex,		// Device index
												arrSubdevices[index_subdevice].m_iSubdeviceIndex,	// Subdevice index, 
												ME_TIMER_CONV_START,								// Timer used 
												&d_achieved_freq,									// Required frequency Hz, Achieved frequency returned here	 
												&i_ticks_low,										// Lower 32 bits of the corresponding tick value returned here
												&i_ticks_high,										// Upper 32 bits of the corresponding tick value returned here
												ME_IO_FREQUENCY_TO_TICKS_NO_FLAGS				);	// No flags

		if(i_me_error != ME_ERRNO_SUCCESS)
		{
			printf("****    meIOStreamFrequencyToTicks - Error: %d    ****\n\n", i_me_error);

			printf("Press any key to terminate\n");
			
			_getch();
			
			meClose(0);
			
			return -1;
		}

		printf("meIOStreamFrequencyToTicks - Required Freq: %lf Achieved Freq: %lf Ticks low: %d Ticks high: %d\n\n", d_req_freq, d_achieved_freq, i_ticks_low, i_ticks_high);

		meIOStreamConfig_t arr_stream_config[1];

		arr_stream_config[0].iChannel = 0;

		arr_stream_config[0].iStreamConfig = 0;
		arr_stream_config[0].iRef = ME_REF_AO_GROUND;
		arr_stream_config[0].iFlags = ME_IO_STREAM_CONFIG_TYPE_NO_FLAGS;

		meIOStreamTrigger_t stream_trigger;

		memset( &stream_trigger, 0, sizeof(meIOStreamTrigger_t) );

		stream_trigger.iAcqStartTrigType = ME_TRIG_TYPE_SW;
		
		// int iAcqStartTrigEdge;
		stream_trigger.iAcqStartTrigChan = ME_TRIG_CHAN_DEFAULT;
		stream_trigger.iAcqStartTicksLow = 0;
		stream_trigger.iAcqStartTicksHigh = 0;
		// int iAcqStartArgs[10];

		stream_trigger.iScanStartTrigType = ME_TRIG_TYPE_FOLLOW;
		//int iScanStartTicksLow;
		//int iScanStartTicksHighw;
		//int iScanStartArgs[10];

		stream_trigger.iConvStartTrigType = ME_TRIG_TYPE_TIMER;
		stream_trigger.iConvStartTicksLow = i_ticks_low;
		stream_trigger.iConvStartTicksHigh = i_ticks_high;
		//int iConvStartArgs[10];

		// int iScanStopTrigType;
		// int iScanStopCount;
		// int iScanStopArgs[10];

		// int iAcqStopTrigType;
		// int iAcqStopCount;
		// int iAcqStopArgs[10];

		stream_trigger.iFlags = ME_IO_STREAM_TRIGGER_TYPE_NO_FLAGS;
		
		i_me_error = meIOStreamConfig(	arrSubdevices[index_subdevice].m_iDeviceIndex,		// Device index
										arrSubdevices[index_subdevice].m_iSubdeviceIndex,	// Subdevice index, 
 										&arr_stream_config[0],								// Pointer to an array of meIOStreamConfig_t structures
										1,													// Number of elements in the stream config array above
										&stream_trigger,									// Pointer to an meIOStreamTrigger_t structure
										0,													// FIFO IRQ threshold - not used here
										ME_IO_STREAM_CONFIG_WRAPAROUND					);	// No flags

		if(i_me_error != ME_ERRNO_SUCCESS)
		{
			printf("****    meIOStreamConfig - Error: %d    ****\n\n", i_me_error);

			printf("Press any key to terminate\n");
			
			_getch();
			
			meClose(0);
			
			return -1;
		}

		double d_phys_min;

		double d_phys_max;

		int i_digital_max;
		
		i_me_error = meQueryRangeInfo(	arrSubdevices[index_subdevice].m_iDeviceIndex,		// Device index
										arrSubdevices[index_subdevice].m_iSubdeviceIndex,	// Subdevice index, 
										0,													// Range index
										NULL,												// Unit returned here - not require
										&d_phys_min,										// Physical minimum returned here
										&d_phys_max,										// Physical maximum returned here
										&i_digital_max									);	// Digital maximum value returned here

		int i_buffer[20000];

		int i_count = 20000;

		for(int index_value = 0; index_value < 20000; index_value++)
		{
			i_buffer[index_value] = index_value * i_digital_max / 20000;
		}
		
		i_me_error = meIOStreamWrite(	arrSubdevices[index_subdevice].m_iDeviceIndex,		// Device index
										arrSubdevices[index_subdevice].m_iSubdeviceIndex,	// Subdevice index, 
										ME_WRITE_MODE_PRELOAD,								// Write mode 
										&i_buffer[0],										// Buffer containing the values to write
										&i_count,											// Size of buffer in data values - Number of data values returned here
										ME_IO_STREAM_WRITE_NO_FLAGS						);	// No flags

		if(i_me_error != ME_ERRNO_SUCCESS)
		{
			printf("****    meIOStreamWrite - ME_WRITE_MODE_PRELOAD - Error: %d    ****\n\n", i_me_error);

			printf("Press any key to terminate\n");
		
			_getch();
			
			meClose(0);
			
			return -1;
		}

		printf("Press any key to start the output\n\n");
			
		_getch();
		
		meIOStreamStart_t arr_stream_start[1];

		arr_stream_start[0].iDevice = arrSubdevices[index_subdevice].m_iDeviceIndex;
		arr_stream_start[0].iSubdevice = arrSubdevices[index_subdevice].m_iSubdeviceIndex;
		arr_stream_start[0].iStartMode = ME_START_MODE_BLOCKING;
		arr_stream_start[0].iTimeOut = 5;
		arr_stream_start[0].iFlags = ME_IO_STREAM_START_TYPE_NO_FLAGS;
		arr_stream_start[0].iErrno = 0;
		
		i_me_error = meIOStreamStart(	&arr_stream_start[0],			// Pointer to an array of meIOStreamStart_t structures 
										1,								// Number of elements in the stream start array above
										ME_IO_STREAM_START_NO_FLAGS	);	// No flags

		if(i_me_error != ME_ERRNO_SUCCESS)
		{
			printf("****    meIOStreamStart - Error: %d    ****\n\n", i_me_error);

			printf("Press any key to terminate\n");
		
			_getch();
			
			meClose(0);
			
			return -1;
		}

		printf("Output started - \n\n");

		printf("Press 'I' to terminate immediately or 'L' to terminate on the last buffer value\n\n");

		bool b_falling = true;

		bool b_terminate_immediately = false;

		while(true)
		{
			if( kbhit() != 0 )
			{
				char ch = _getch();
				
				if( (ch == 'i')||(ch == 'I') )
				{
					b_terminate_immediately = true;
					
					break;
				}
				else if( (ch == 'l')||(ch == 'L') )
				{
					b_terminate_immediately = false;
					
					break;
				}
			}
		}

		meIOStreamStop_t arr_stream_stop[1];

		arr_stream_stop[0].iDevice = arrSubdevices[index_subdevice].m_iDeviceIndex;
		arr_stream_stop[0].iSubdevice = arrSubdevices[index_subdevice].m_iSubdeviceIndex;

		if(b_terminate_immediately)
		{
			arr_stream_stop[0].iStopMode = ME_STOP_MODE_IMMEDIATE;
		}
		else
		{
			arr_stream_stop[0].iStopMode = ME_STOP_MODE_LAST_VALUE;
		}

		arr_stream_stop[0].iFlags = ME_IO_STREAM_STOP_TYPE_NO_FLAGS;
		arr_stream_stop[0].iErrno = 0;

		i_me_error = meIOStreamStop(&arr_stream_stop[0],			// Pointer to an array of meIOStreamStop_t structures  
									1,								// Number of elements in the stream stop array above
									ME_IO_STREAM_STOP_NO_FLAGS);	// No flags

		if(i_me_error != ME_ERRNO_SUCCESS)
		{
			printf("****    meIOStreamStop - Error: %d    ****\n\n", i_me_error);

			printf("Press any key to terminate\n");
			
			_getch();
		
			meClose(0);
		
			return(-1);
		}

		printf("Output ended\n\n");

		printf("Press any key to continue\n");
		
		_getch();
	}

	// ---------------------------------------------------------------------
	

	meClose(0);
	meCloseDynamicAccess();
	
	printf("Program completed successfully - Press any key to terminate\n\n");

	_getch();
	
	return 0;
}

