// Dlg_ME-5xxx.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "Dlg_ME-5xxx.h"
#include "ME5xxxPropertySheet.h"
#include "ME5xxxPPDI.h"
#include "ME5xxxPPDO.h"
#include "ME5xxxPPFI.h"
#include "ME5xxxPPFO.h"
#include "ME5xxxPPDIO.h"

#ifdef WIN64

#pragma comment (lib, "..\\meIDSmain64.lib")

#else

#pragma comment (lib, "..\\meIDSmain.lib")

#endif

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CDlg_ME5xxxApp

BEGIN_MESSAGE_MAP(CDlg_ME5xxxApp, CWinApp)
	ON_COMMAND(ID_HELP, &CWinApp::OnHelp)
END_MESSAGE_MAP()


// CDlg_ME5xxxApp construction

CDlg_ME5xxxApp::CDlg_ME5xxxApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}


// The one and only CDlg_ME5xxxApp object

CDlg_ME5xxxApp theApp;


// CDlg_ME5xxxApp initialization

BOOL CDlg_ME5xxxApp::InitInstance()
{
	CWinApp::InitInstance();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	// of your final executable, you should remove from the following
	// the specific initialization routines you do not need
	// Change the registry key under which our settings are stored
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization
	SetRegistryKey(_T("Local AppWizard-Generated Applications"));

	int i_me_error;

	// Enable the default Proc

	meErrorSetDefaultProc(ME_SWITCH_ENABLE);

	// Display library version in title

	int i_version_library;
	
	i_me_error = meQueryVersionLibrary(&i_version_library);

	if(i_me_error != ME_ERRNO_SUCCESS)
	{
		return(FALSE);
	}

	i_me_error = meOpen(0);

	if(i_me_error != ME_ERRNO_SUCCESS)
	{
		return(FALSE);
	}

	// Display main driver version in title

	int i_version_main_driver;

	i_me_error = meQueryVersionMainDriver(&i_version_main_driver);

	if(i_me_error != ME_ERRNO_SUCCESS)
	{
		return(FALSE);
	}

/*
	char sz_buffer[256];

	sprintf(&sz_buffer[0], "ME-IDS AI Streaming  -  Library Version: %d.%d.%d.%d  Main Driver Version:  %d.%d.%d.%d", 
							(i_version_library >> 24) & 0x000000FF, (i_version_library >> 16) & 0x000000FF, (i_version_library >> 8) & 0x000000FF, i_version_library & 0x000000FF,
							 (i_version_main_driver >> 24) & 0x000000FF, (i_version_main_driver >> 16) & 0x000000FF, (i_version_main_driver >> 8) & 0x000000FF, i_version_main_driver & 0x000000FF );
	
	SetWindowText(&sz_buffer[0]);
*/

	// Query number of devices

	int i_number_of_devices;
	
	i_me_error = meQueryNumberDevices(&i_number_of_devices);

	if(i_me_error != ME_ERRNO_SUCCESS)
	{
		return(FALSE);
	}

	if(i_number_of_devices == 0)
	{
		AfxMessageBox( _T("No ME-IDS devices found in System"), MB_OK | MB_ICONEXCLAMATION | MB_SETFOREGROUND );

		return(FALSE);
	} 

	// Find the first ME-5xxx board

	int i_index_me5000_device = -1;

	for(int index_device = 0; index_device < i_number_of_devices; index_device++)
	{
		int i_vendor_id;
		int i_device_id;
		int i_serial_no;
		int i_bus_type;
		int i_bus_no;
		int i_dev_no;
		int i_func_no;
		int i_plugged;
		
		i_me_error = meQueryInfoDevice(	index_device,				// Device index
										&i_vendor_id,				// Vendor ID returned here - not required				
										&i_device_id,				// Device ID returned here - not required
										&i_serial_no,				// Serial number returned here - not required
										&i_bus_type,				// Bus type returned here - not required
										&i_bus_no,					// Bus number returned here - not required
										&i_dev_no,					// Bus device number returned here - not required
										&i_func_no,					// Bus function number returned here - not required
										&i_plugged				);	// Plugged status returned here

		if(i_plugged != ME_PLUGGED_IN)
		{
			continue;
		}

		if( (i_device_id & 0xF000) == 0x5000 )
		{
			i_index_me5000_device = index_device;
			
			break;
		}
	}

	if(i_index_me5000_device == -1)
	{
		AfxMessageBox( _T("No ME-5xxx devices found in System"), MB_OK | MB_ICONEXCLAMATION | MB_SETFOREGROUND );

		return(FALSE);
	} 

	int i_number_of_subdevices;

	meQueryNumberSubdevices(i_index_me5000_device,		// Device index
							&i_number_of_subdevices);	// Number of sub-devices returned here

	CME5xxxPropertySheet me5xxx_ps( _T("Meilhaus Electronic    -    ME5xxx Test Programm") );

	TCHAR sz_title[8][32];

	for(int index_subdevice = 0; index_subdevice < i_number_of_subdevices; index_subdevice++) 
	{
		int i_subdevice_type;
		
		int i_subdevice_subtype;
		
		i_me_error = meQuerySubdeviceType(	i_index_me5000_device,		// Device index
											index_subdevice,			// Subdevice index
											&i_subdevice_type,			// Sub-device type returned here
											&i_subdevice_subtype	);	// Sub-device sub-type returned here

		if(i_me_error != ME_ERRNO_SUCCESS)
		{
			break;
		}

		_stprintf_s(&sz_title[index_subdevice][0], 32, _T("Sub-device %d  -  "), index_subdevice);

		CME5xxxPP* p_pp;
		
		switch(i_subdevice_type)
		{
		case ME_TYPE_DI:

			_tcscat_s( &sz_title[index_subdevice][0], 32, _T("DI") );

			p_pp = new CME5xxxPPDI;

			break;

		case ME_TYPE_DO:

			_tcscat_s( &sz_title[index_subdevice][0], 32, _T("DO") );

			p_pp = new CME5xxxPPDO;

			break;

		case ME_TYPE_DIO:

			_tcscat_s( &sz_title[index_subdevice][0], 32, _T("DIO") );

			p_pp = new CME5xxxPPDIO;

			break;

		case ME_TYPE_FI:

			_tcscat_s( &sz_title[index_subdevice][0], 32, _T("FI") );

			p_pp = new CME5xxxPPFI;

			break;

		case ME_TYPE_FO:

			_tcscat_s( &sz_title[index_subdevice][0], 32, _T("FO") );

			p_pp = new CME5xxxPPFO;

			break;
		}

		p_pp->m_iDeviceIndex = i_index_me5000_device;

		p_pp->m_iSubdeviceIndex = index_subdevice;

		p_pp->m_psp.dwFlags|= PSP_USETITLE;

		p_pp->m_psp.pszTitle = &sz_title[index_subdevice][0];

		me5xxx_ps.AddPage(p_pp);
	}

	m_pMainWnd = &me5xxx_ps;

	INT_PTR nResponse = me5xxx_ps.DoModal();

	if (nResponse == IDOK)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with OK
	}
	else if (nResponse == IDCANCEL)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with Cancel
	}

	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}
